#include<qapplication.h>
#include<qtextedit.h>
#include<qgroupbox.h>
#include<qlineedit.h>
#include<qlabel.h>
#include<qcheckbox.h>
#include<qtextedit.h>
#include<qcombobox.h>
#include<qpushbutton.h>
#include<qmessagebox.h>
#include<qinputdialog.h>
#include<qspinbox.h>
#include<qtimer.h>
#include<qmenubar.h>
#include<qpopupmenu.h>
#include<qtabwidget.h>
#include<qca.h>
#include <qsocket.h>
#include <qvbox.h>
#include <qtextview.h>
//#include<iris/xmpp.h>
#include"xmpp.h"
#include"xmpp_tasks.h"
#include"im.h"

#include"xmpp_jingle.h"
#include"protocol.h"

#include<stdlib.h>
#include<time.h>

#include<stdio.h>

class Client : public QVBox
{
    Q_OBJECT
public:
    Client( const QString &host, Q_UINT16 port )// : QVBox(0, 0, WStyle_StaysOnTop)
    {
		// GUI layout
		outText = new QTextView( this );
		inText = new QTextView( this );

		QPushButton *start = new QPushButton( tr("Call") , this );
//		QPushButton *redirecting = new QPushButton( tr("Redirect") , this );
		QPushButton *terminate = new QPushButton( tr("Terminate") , this );
		QPushButton *quit = new QPushButton( tr("Quit") , this );

		connect( start, SIGNAL(clicked()), SLOT(sendToServer()) );
//		connect( close, SIGNAL(clicked()), SLOT(closeConnection()) );
		connect( terminate, SIGNAL(clicked()), XMPP::JingleSession::session(), SLOT(terminate()) );
		connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
		
		setGeometry(5, 20, 600, 400);

		conn = new XMPP::AdvancedConnector;
		stream = new XMPP::ClientStream(conn, 0);
		client = new XMPP::Client(this);
		connect(client, SIGNAL(xmlOutgoing(const QString &)), SLOT(writed(const QString &)));
		XMPP::Jid jidFrom("romeo@montague.net/orchard");
		client->connectToServer(stream, jidFrom);
		client->start(jidFrom.host(), jidFrom.user(), "", jidFrom.resource());

		// create the socket and connect various of its signals
		socket = new QSocket( this );
		connect( socket, SIGNAL(connected()),
			SLOT(socketConnected()) );
		connect( socket, SIGNAL(connectionClosed()),
			SLOT(socketConnectionClosed()) );
		connect( socket, SIGNAL(readyRead()),
			SLOT(socketReadyRead()) );
		connect( socket, SIGNAL(error(int)),
			SLOT(socketError(int)) );
		// connect to the server
		inText->append( tr("Trying to connect to the server\n") );
		socket->connectToHost( host, port );
    }

    ~Client()
    {
		delete stream;
		delete conn;
    }

private slots:
    void closeConnection()
    {
	socket->close();
	if ( socket->state() == QSocket::Closing ) {
	    // We have a delayed close.
	    connect( socket, SIGNAL(delayedCloseFinished()),
		    SLOT(socketClosed()) );
	} else {
	    // The socket is closed.
	    socketClosed();
	}
    }

    void sendToServer()
    {
		XMPP::JingleSession::session()->call(client, "juliet@capulet.com/balcony");
    }

    void socketReadyRead()
    {
		QString s;
		// read from the server
		while ( socket->canReadLine() ) {
			s += socket->readLine();
		}
		if(s.isEmpty())
			return;
		inText->append(s);
		QDomDocument doc;
		doc.setContent(s);
		QDomElement e = doc.firstChild().toElement();
		if (client->rootTask()->take(e))
			qDebug("Ok");
		else
			qDebug("Bad");
    }

    void socketConnected()
    {
		inText->append( tr("Connected to server\n") );
		XMPP::JT_DiscoInfo *jt = new XMPP::JT_DiscoInfo(client->rootTask());
		jt->get("juliet@capulet.com/balcony");
		jt->go(true);
    }

    void socketConnectionClosed()
    {
	inText->append( tr("Connection closed by the server\n") );
    }

    void socketClosed()
    {
	inText->append( tr("Connection closed\n") );
    }

    void socketError( int e )
    {
	inText->append( tr("Error number %1 occurred\n").arg(e) );
    }
    
    void writed( const QString &s )
    {
		QDomDocument doc;
		doc.setContent(s);
		QDomElement e = doc.firstChild().toElement();
		e.setAttribute("from", "romeo@montague.net/orchard");
		QTextStream os(socket);
		os<<doc.toString()<< "\n";
		outText->append(doc.toString());
    }

private:
    QSocket *socket;
    QTextView *inText, *outText;
    //QTextView *inputText;
    XMPP::Client * client;
    XMPP::ClientStream *stream;
    XMPP::AdvancedConnector *conn;
};

#include"xmpptest.moc"

int main(int argc, char **argv)
{
#ifdef Q_OS_WIN32
	QApplication::addLibraryPath(".");
	putenv("SASL_PATH=.\\sasl");
#endif
	QApplication app(argc, argv);
	// seed the random number generator (needed at least for HttpPoll)
	srand(time(NULL));
    Client client( argc<2 ? "localhost" : argv[1], 4242 );
    app.setMainWidget( &client );
    QObject::connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()));
    client.show();
    app.exec();

	// we need this for a clean exit
	QCA::unloadAllPlugins();

	return 0;
}
